=== modified file 'src/tools.cc'
--- src/tools.cc	2012-11-29 08:51:27 +0000
+++ src/tools.cc	2012-12-28 16:02:34 +0000
@@ -134,24 +134,21 @@
 
     char filename[] = "/tmp/squid-XXXXXX";
     int tfd = mkstemp(filename);
-
     if (tfd < 0)
         return;
 
-    if ((fp = fdopen(tfd, "w")) == NULL)
-        return;
-
 #else
 
     char *filename;
-
     if ((filename = tempnam(NULL, APP_SHORTNAME)) == NULL)
         return;
 
+#endif
+
+    const mode_t prev_umask=umask(S_IRWXU);
     if ((fp = fopen(filename, "w")) == NULL)
         return;
-
-#endif
+    umask(prev_umask); //restore the previous umask
 
     if (Config.EmailFrom)
         fprintf(fp, "From: %s\n", Config.EmailFrom);

